#include "DxLib.h"
#include <malloc.h>

#define MOVESPEED			(20.0)			// ړx
#define SPHERESIZE			(150.0f)		// ̂̃TCY
#define COLLWIDTH			(400.0f)		// 蔻̃TCY

// |Sm̘Aۑׂ̍\
struct POLYLINKINFO
{
	int LinkPolyIndex[ 3 ] ;			// |S̎O̕ӂƂꂼאڂĂ|S̃|Sԍ( -1Fאڃ|S  -1ȊOF|Sԍ )
	float LinkPolyDistance[ 3 ] ;			// אڂĂ|SƂ̋
	VECTOR CenterPosition ;				// |S̒SW
} ;

// oHTp̂P|S̏
struct PATHPLANNING_UNIT
{
	int PolyIndex ;					// |Sԍ
	float TotalDistance ;				// oHTł̃|SɓB܂łɒʉ߂|SԂ̋̍v
	int PrevPolyIndex ;				// oHTŊm肵oḦÕ|S( |SoHɖꍇ -1 )
	int NextPolyIndex ;				// oHTŊm肵oḦ̃|S( |SoHɖꍇ -1 )
	PATHPLANNING_UNIT *ActiveNextUnit ;		// oHTΏۂɂȂĂ鎟̃|S̃AhXi[ϐ
} ;

// oHTŎgpۑׂ̍\
struct PATHPLANNING
{
	VECTOR StartPosition ;				// Jnʒu
	VECTOR GoalPosition ;				// ڕWʒu
	PATHPLANNING_UNIT *UnitArray ;			// oHTŎgpS|S̏z񂪊i[ꂽ̈̐擪AhXi[ϐ
	PATHPLANNING_UNIT *ActiveFirstUnit ;		// oHTΏۂɂȂĂ|SQ̍ŏ̃|Sւ̃AhXi[ϐ
	PATHPLANNING_UNIT *StartUnit ;			// oH̃X^[gn_ɂ|Sւ̃AhXi[ϐ
	PATHPLANNING_UNIT *GoalUnit ;			// oH̃S[n_ɂ|Sւ̃AhXi[ϐ
} ;

// ToHړ鏈ɎgpZ߂\
struct PATHMOVEINFO
{
	int NowPolyIndex ;				// ݏĂ|S̔ԍ
	VECTOR NowPosition ;				// ݈ʒu
	VECTOR MoveDirection ;				// ړ
	PATHPLANNING_UNIT *NowPathPlanningUnit ;	// ݏĂ|ŠoHT񂪊i[Ă郁AhXi[ϐ
	PATHPLANNING_UNIT *TargetPathPlanningUnit ;	// ̒Ԓn_ƂȂoH̃|ŠoHT񂪊i[Ă郁AhXi[ϐ
} ;


int StageModelHandle ;			// Xe[Wfnh
MV1_REF_POLYGONLIST PolyList ;		// Xe[Wf̃|S

POLYLINKINFO *PolyLinkInfo ;		// Xe[Wf̑S|Śu|Sm̘Av̔z񂪊i[i[ꂽGA̐擪AhXi[ϐ
PATHPLANNING PathPlanning ;		// oHTp̍\
PATHMOVEINFO PathMove ;			// ToHړ鏈ɎgpZ߂\


int CheckOnPolyIndex( VECTOR Pos ) ;						// w̍W̒AႵ͒ɂ|S̔ԍ擾( |Sꍇ -1 Ԃ )

void SetupPolyLinkInfo( void ) ;						// |Sm̘A\z
void TerminatePolyLinkInfo( void ) ;						// |Sm̘Ǎns
bool CheckPolyMove( VECTOR StartPos, VECTOR TargetPos ) ;			// |Sm̘AgpĎw̓̍WԂ𒼐IɈړł邩ǂ`FbN( ߂l  true:IɈړł  false:IɈړłȂ )
bool CheckPolyMoveWidth( VECTOR StartPos, VECTOR TargetPos, float Width ) ;	// |Sm̘AgpĎw̓̍WԂ𒼐IɈړł邩ǂ`FbN( ߂l  true:IɈړł  false:IɈړłȂ )( w )

bool SetupPathPlanning( VECTOR StartPos, VECTOR GoalPos ) ;			// ŵQ_̌oHT( ߂l  true:oH\z  false:oH\zs( X^[gn_ƃS[n_qoH ) )
void TerminatePathPlanning( void ) ;						// oHŤn

void MoveInitialize( void ) ;							// ToHړ鏈̏s֐
void MoveProcess( void ) ;							// ToHړ鏈̂Pt[̏s֐
bool RefreshMoveDirection( void ) ;						// ToHړ鏈ňړXV鏈s֐( ߂l  true:S[ɒH蒅Ă  false:S[ɒH蒅ĂȂ )



// w̍W̒AႵ͒ɂ|S̔ԍ擾( |Sꍇ -1 Ԃ )
int CheckOnPolyIndex( VECTOR Pos )
{
	int i ;
	VECTOR LinePos1 ;
	VECTOR LinePos2 ;
	HITRESULT_LINE HitRes ;
	MV1_REF_POLYGON *RefPoly ;

	// w̍WYɑ傫Lт̂QWZbg
	LinePos1 = VGet( Pos.x,  1000000.0f, Pos.z ) ;
	LinePos2 = VGet( Pos.x, -1000000.0f, Pos.z ) ;

	// Xe[Wf̃|S̐JԂ
	RefPoly = PolyList.Polygons ;
	for( i = 0 ; i < PolyList.PolygonNum ; i ++, RefPoly ++ )
	{
		// Ɛڂ|S炻̃|S̔ԍԂ
		HitRes = HitCheck_Line_Triangle(
					LinePos1,
					LinePos2,
					PolyList.Vertexs[ RefPoly->VIndex[ 0 ] ].Position,
					PolyList.Vertexs[ RefPoly->VIndex[ 1 ] ].Position,
					PolyList.Vertexs[ RefPoly->VIndex[ 2 ] ].Position
				) ;
		if( HitRes.HitFlag )
		{
			return i ;
		}
	}

	// ɗƐڂ|SƂƂȂ̂ -1 Ԃ
	return -1 ;
}


// |Sm̘A\z
void SetupPolyLinkInfo( void )
{
	int i ;
	int j ;
	POLYLINKINFO *PLInfo ;
	POLYLINKINFO *PLInfoSub ;
	MV1_REF_POLYGON *RefPoly ;
	MV1_REF_POLYGON *RefPolySub ;

	// Xe[WfŜ̎QƗpbV\z
	MV1SetupReferenceMesh( StageModelHandle, 0, TRUE ) ;

	// Xe[WfŜ̎QƗpbV̏擾
	PolyList = MV1GetReferenceMesh( StageModelHandle, 0, TRUE ) ;

	// Xe[Wf̑S|S̘Ai[ׂ̃̈mۂ
	PolyLinkInfo = ( POLYLINKINFO * )malloc( sizeof( POLYLINKINFO ) * PolyList.PolygonNum ) ;

	// S|S̒SWZo
	PLInfo = PolyLinkInfo ;
	RefPoly = PolyList.Polygons ;
	for( i = 0 ; i < PolyList.PolygonNum ; i ++, PLInfo ++, RefPoly ++ )
	{
		PLInfo->CenterPosition =
			VScale( VAdd( PolyList.Vertexs[ RefPoly->VIndex[ 0 ] ].Position,
					VAdd( PolyList.Vertexs[ RefPoly->VIndex[ 1 ] ].Position,
					      PolyList.Vertexs[ RefPoly->VIndex[ 2 ] ].Position ) ), 1.0f / 3.0f ) ;
	}

	// |Sm̗אڏ̍\z
	PLInfo = PolyLinkInfo ;
	RefPoly = PolyList.Polygons ;
	for( i = 0 ; i < PolyList.PolygonNum ; i ++, PLInfo ++, RefPoly ++ )
	{
		// eӂɗאڃ|S͖ȀԂɂĂ
		PLInfo->LinkPolyIndex[ 0 ] = -1 ;
		PLInfo->LinkPolyIndex[ 1 ] = -1 ;
		PLInfo->LinkPolyIndex[ 2 ] = -1 ;

		// אڂ|ST߂Ƀ|S̐JԂ
		RefPolySub = PolyList.Polygons ;
		PLInfoSub = PolyLinkInfo ;
		for( j = 0 ; j < PolyList.PolygonNum ; j ++, RefPolySub ++, PLInfoSub ++ )
		{
			// g̃|S牽̃|S
			if( i == j )
				continue ;

			// |S̒_ԍ01Ō`ӂƗאڂĂאڏɒǉ
			if( PLInfo->LinkPolyIndex[ 0 ] == -1 &&
				( ( RefPoly->VIndex[ 0 ] == RefPolySub->VIndex[ 0 ] && RefPoly->VIndex[ 1 ] == RefPolySub->VIndex[ 2 ] ) ||
				  ( RefPoly->VIndex[ 0 ] == RefPolySub->VIndex[ 1 ] && RefPoly->VIndex[ 1 ] == RefPolySub->VIndex[ 0 ] ) ||
				  ( RefPoly->VIndex[ 0 ] == RefPolySub->VIndex[ 2 ] && RefPoly->VIndex[ 1 ] == RefPolySub->VIndex[ 1 ] ) ) )
			{
				PLInfo->LinkPolyIndex[ 0 ] = j ;
				PLInfo->LinkPolyDistance[ 0 ] = VSize( VSub( PLInfoSub->CenterPosition, PLInfo->CenterPosition ) ) ;
			}
			else
			// |S̒_ԍ12Ō`ӂƗאڂĂאڏɒǉ
			if( PLInfo->LinkPolyIndex[ 1 ] == -1 &&
				( ( RefPoly->VIndex[ 1 ] == RefPolySub->VIndex[ 0 ] && RefPoly->VIndex[ 2 ] == RefPolySub->VIndex[ 2 ] ) ||
				  ( RefPoly->VIndex[ 1 ] == RefPolySub->VIndex[ 1 ] && RefPoly->VIndex[ 2 ] == RefPolySub->VIndex[ 0 ] ) ||
				  ( RefPoly->VIndex[ 1 ] == RefPolySub->VIndex[ 2 ] && RefPoly->VIndex[ 2 ] == RefPolySub->VIndex[ 1 ] ) ) )
			{
				PLInfo->LinkPolyIndex[ 1 ] = j ;
				PLInfo->LinkPolyDistance[ 1 ] = VSize( VSub( PLInfoSub->CenterPosition, PLInfo->CenterPosition ) ) ;
			}
			else
			// |S̒_ԍ20Ō`ӂƗאڂĂאڏɒǉ
			if( PLInfo->LinkPolyIndex[ 2 ] == -1 &&
				( ( RefPoly->VIndex[ 2 ] == RefPolySub->VIndex[ 0 ] && RefPoly->VIndex[ 0 ] == RefPolySub->VIndex[ 2 ] ) ||
				  ( RefPoly->VIndex[ 2 ] == RefPolySub->VIndex[ 1 ] && RefPoly->VIndex[ 0 ] == RefPolySub->VIndex[ 0 ] ) ||
				  ( RefPoly->VIndex[ 2 ] == RefPolySub->VIndex[ 2 ] && RefPoly->VIndex[ 0 ] == RefPolySub->VIndex[ 1 ] ) ) )
			{
				PLInfo->LinkPolyIndex[ 2 ] = j ;
				PLInfo->LinkPolyDistance[ 2 ] = VSize( VSub( PLInfoSub->CenterPosition, PLInfo->CenterPosition ) ) ;
			}
		}
	}
}

// |Sm̘Ǎns
void TerminatePolyLinkInfo( void )
{
	// |Sm̘Ai[Ă̈
	free( PolyLinkInfo ) ;
	PolyLinkInfo = NULL ;
}

// |Sm̘AgpĎw̓̍WԂ𒼐IɈړł邩ǂ`FbN( ߂l  true:IɈړł  false:IɈړłȂ )
bool CheckPolyMove( VECTOR StartPos, VECTOR TargetPos )
{
	int StartPoly ;
	int TargetPoly ;
	POLYLINKINFO *PInfoStart ;
	POLYLINKINFO *PInfoTarget ;
	int i, j ;
	VECTOR_D StartPosD ;
	VECTOR_D TargetPosD ;
	VECTOR_D PolyPos[ 3 ] ;
	int CheckPoly[ 3 ] ;
	int CheckPolyPrev[ 3 ] ;
	int CheckPolyNum ;
	int CheckPolyPrevNum ;
	int NextCheckPoly[ 3 ] ;
	int NextCheckPolyPrev[ 3 ] ;
	int NextCheckPolyNum ;
	int NextCheckPolyPrevNum ;

	// JnWƖڕWW yWl 0.0f ɂāAʏ̔ɂ
	StartPos.y = 0.0f ;
	TargetPos.y = 0.0f ;

	// xグ邽߂ double^ɂ
	StartPosD = VConvFtoD( StartPos ) ;
	TargetPosD = VConvFtoD( TargetPos ) ;

	// JnWƖڕWW̒AႵ͒ɑ݂|S
	StartPoly = CheckOnPolyIndex( StartPos ) ;
	TargetPoly = CheckOnPolyIndex( TargetPos ) ;

	// |S݂ȂړłȂ̂ false Ԃ
	if( StartPoly == -1 || TargetPoly == -1 )
		return false ;

	// JnWƖڕWW̒AႵ͒ɑ݂|S̘ÃAhX擾Ă
	PInfoStart = &PolyLinkInfo[ StartPoly ] ;
	PInfoTarget = &PolyLinkInfo[ TargetPoly ] ;

	// wɂ邩ǂ`FbN|SƂĊJnW̒AႵ͒ɑ݂|So^
	CheckPolyNum = 1 ;
	CheckPoly[ 0 ] = StartPoly ;
	CheckPolyPrevNum = 0 ;
	CheckPolyPrev[ 0 ] = -1 ;

	// ʂo܂ŖŌJԂ
	for(;;)
	{
		// ̃[vŃ`FbNΏۂɂȂ|S̐ZbgĂ
		NextCheckPolyNum = 0 ;

		// ̃[vŃ`FbNΏۂO|S̐ZbgĂ
		NextCheckPolyPrevNum = 0 ;

		// `FbNΏۂ̃|S̐JԂ
		for( i = 0 ; i < CheckPolyNum ; i ++ )
		{
			// `FbNΏۂ̃|ŜRW擾
			PolyPos[ 0 ] = VConvFtoD( PolyList.Vertexs[ PolyList.Polygons[ CheckPoly[ i ] ].VIndex[ 0 ] ].Position ) ;
			PolyPos[ 1 ] = VConvFtoD( PolyList.Vertexs[ PolyList.Polygons[ CheckPoly[ i ] ].VIndex[ 1 ] ].Position ) ;
			PolyPos[ 2 ] = VConvFtoD( PolyList.Vertexs[ PolyList.Polygons[ CheckPoly[ i ] ].VIndex[ 2 ] ].Position ) ;

			// yW0.0ɂāAʓIȔs悤ɂ
			PolyPos[ 0 ].y = 0.0 ;
			PolyPos[ 1 ].y = 0.0 ;
			PolyPos[ 2 ].y = 0.0 ;

			// |S̒_ԍ01̕ӂɗאڂ|S݂ꍇŁA
			// ӂ̐ƈړJn_AI_Ō`ڂĂ if ^ɂȂ
			if( PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 0 ] != -1 &&
				Segment_Segment_MinLength_SquareD( StartPosD, TargetPosD, PolyPos[ 0 ], PolyPos[ 1 ] ) < 0.001 )
			{
				// ӂƐڂĂ|SڕWWɑ݂|S
				// JnWڕWW܂œr؂Ȃ|S݂ƂƂȂ̂ true Ԃ
				if( PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 0 ] == TargetPoly )
					return true ;

				// ӂƐڂĂ|S̃`FbNΏۂ̃|Sɉ

				// ɓo^Ă|S̏ꍇ͉Ȃ
				for( j = 0 ; j < NextCheckPolyNum ; j ++ )
				{
					if( NextCheckPoly[ j ] == PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 0 ] )
						break ;
				}
				if( j == NextCheckPolyNum )
				{
					// ̃[vŏO|S̑Ώۂɉ

					// ɓo^Ă鏜O|S̏ꍇ͉Ȃ
					for( j = 0 ; j < NextCheckPolyPrevNum ; j ++ )
					{
						if( NextCheckPolyPrev[ j ] == CheckPoly[ i ] )
							break ;
					}
					if( j == NextCheckPolyPrevNum )
					{
						NextCheckPolyPrev[ NextCheckPolyPrevNum ] = CheckPoly[ i ] ;
						NextCheckPolyPrevNum ++ ;
					}

					// Õ[vŃ`FbNΏۂɂȂ|S̏ꍇȂ
					for( j = 0 ; j < CheckPolyPrevNum ; j ++ )
					{
						if( CheckPolyPrev[ j ] == PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 0 ] )
							break ;
					}
					if( j == CheckPolyPrevNum )
					{
						// ܂ŗQ̃`FbNΏۂ̃|Sɉ
						NextCheckPoly[ NextCheckPolyNum ] = PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 0 ] ;
						NextCheckPolyNum ++ ;
					}
				}
			}

			// |S̒_ԍ12̕ӂɗאڂ|S݂ꍇŁA
			// ӂ̐ƈړJn_AI_Ō`ڂĂ if ^ɂȂ
			if( PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 1 ] != -1 &&
				Segment_Segment_MinLength_SquareD( StartPosD, TargetPosD, PolyPos[ 1 ], PolyPos[ 2 ] ) < 0.001 )
			{
				// ӂƐڂĂ|SڕWWɑ݂|S
				// JnWڕWW܂œr؂Ȃ|S݂ƂƂȂ̂ true Ԃ
				if( PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 1 ] == TargetPoly )
					return true ;

				// ӂƐڂĂ|S̃`FbNΏۂ̃|Sɉ

				// ɓo^Ă|S̏ꍇ͉Ȃ
				for( j = 0 ; j < NextCheckPolyNum ; j ++ )
				{
					if( NextCheckPoly[ j ] == PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 1 ] )
						break ;
				}
				if( j == NextCheckPolyNum )
				{
					// ɓo^Ă鏜O|S̏ꍇ͉Ȃ
					for( j = 0 ; j < NextCheckPolyPrevNum ; j ++ )
					{
						if( NextCheckPolyPrev[ j ] == CheckPoly[ i ] )
							break ;
					}
					if( j == NextCheckPolyPrevNum )
					{
						NextCheckPolyPrev[ NextCheckPolyPrevNum ] = CheckPoly[ i ] ;
						NextCheckPolyPrevNum ++ ;
					}

					// Õ[vŃ`FbNΏۂɂȂ|S̏ꍇȂ
					for( j = 0 ; j < CheckPolyPrevNum ; j ++ )
					{
						if( CheckPolyPrev[ j ] == PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 1 ] )
							break ;
					}
					if( j == CheckPolyPrevNum )
					{
						// ܂ŗQ̃`FbNΏۂ̃|Sɉ
						NextCheckPoly[ NextCheckPolyNum ] = PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 1 ] ;
						NextCheckPolyNum ++ ;
					}
				}
			}

			// |S̒_ԍ20̕ӂɗאڂ|S݂ꍇŁA
			// ӂ̐ƈړJn_AI_Ō`ڂĂ if ^ɂȂ
			if( PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 2 ] != -1 &&
				Segment_Segment_MinLength_SquareD( StartPosD, TargetPosD, PolyPos[ 2 ], PolyPos[ 0 ] ) < 0.001 )
			{
				// ӂƐڂĂ|SڕWWɑ݂|S
				// JnWڕWW܂œr؂Ȃ|S݂ƂƂȂ̂ true Ԃ
				if( PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 2 ] == TargetPoly )
					return true ;

				// ӂƐڂĂ|S̃`FbNΏۂ̃|Sɉ

				// ɓo^Ă|S̏ꍇ͉Ȃ
				for( j = 0 ; j < NextCheckPolyNum ; j ++ )
				{
					if( NextCheckPoly[ j ] == PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 2 ] )
						break ;
				}
				if( j == NextCheckPolyNum )
				{
					// ɓo^Ă鏜O|S̏ꍇ͉Ȃ
					for( j = 0 ; j < NextCheckPolyPrevNum ; j ++ )
					{
						if( NextCheckPolyPrev[ j ] == CheckPoly[ i ] )
							break ;
					}
					if( j == NextCheckPolyPrevNum )
					{
						NextCheckPolyPrev[ NextCheckPolyPrevNum ] = CheckPoly[ i ] ;
						NextCheckPolyPrevNum ++ ;
					}

					// Õ[vŃ`FbNΏۂɂȂ|S̏ꍇȂ
					for( j = 0 ; j < CheckPolyPrevNum ; j ++ )
					{
						if( CheckPolyPrev[ j ] == PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 2 ] )
							break ;
					}
					if( j == CheckPolyPrevNum )
					{
						// ܂ŗQ̃`FbNΏۂ̃|Sɉ
						NextCheckPoly[ NextCheckPolyNum ] = PolyLinkInfo[ CheckPoly[ i ] ].LinkPolyIndex[ 2 ] ;
						NextCheckPolyNum ++ ;
					}
				}
			}
		}

		// ̃[vŃ`FbNΏۂɂȂ|SȂƂƂ
		// ړJn_AI_Ō`Ɛڂ`FbNΏۂ̃|Sɗאڂ
		// |SȂƂƂȂ̂ŁAIȈړ͂łȂƂƂ false Ԃ
		if( NextCheckPolyNum == 0 )
		{
			return false ;
		}

		// Ƀ`FbNΏۂƂȂ|S̏Rs[
		for( i = 0 ; i < NextCheckPolyNum ; i ++ )
		{
			CheckPoly[ i ] = NextCheckPoly[ i ] ;
		}
		CheckPolyNum = NextCheckPolyNum ;

		// Ƀ`FbNΏۊOƂȂ|S̏Rs[
		for( i = 0 ; i < NextCheckPolyPrevNum ; i ++ )
		{
			CheckPolyPrev[ i ] = NextCheckPolyPrev[ i ] ;
		}
		CheckPolyPrevNum = NextCheckPolyPrevNum ;
	}
}

// |Sm̘AgpĎw̓̍WԂ𒼐IɈړł邩ǂ`FbN( ߂l  true:IɈړł  false:IɈړłȂ )( w )
bool CheckPolyMoveWidth( VECTOR StartPos, VECTOR TargetPos, float Width )
{
	VECTOR Direction ;
	VECTOR SideDirection ;
	VECTOR TempVec ;

	// ŏɊJnWڕWWɒIɈړł邩ǂ`FbN
	if( CheckPolyMove( StartPos, TargetPos ) == false )
		return false ;

	// JnWڕWWɌxNgZo
	Direction = VSub( TargetPos, StartPos ) ;

	// yW 0.0f ɂĕʓIȃxNgɂ
	Direction.y = 0.0f ; 

	// JnWڕWWɌxNgɒpȐKxNgZo
	SideDirection = VCross( Direction, VGet( 0.0f, 1.0f, 0.0f ) ) ;
	SideDirection = VNorm( SideDirection ) ;

	// JnWƖڕWW Width / 2.0f ɂ炵āAēxIɈړł邩ǂ`FbN
	TempVec = VScale( SideDirection, Width / 2.0f ) ;
	if( CheckPolyMove( VAdd( StartPos,  TempVec ), VAdd( TargetPos, TempVec ) ) == false )
		return false ;

	// JnWƖڕWW Width / 2.0f OƂ͋t̐ɂ炵āAēxIɈړł邩ǂ`FbN
	TempVec = VScale( SideDirection, -Width / 2.0f ) ;
	if( CheckPolyMove( VAdd( StartPos,  TempVec ), VAdd( TargetPos, TempVec ) ) == false )
		return false ;

	// ܂łw̕ĂIɈړłƂƂȂ̂ true Ԃ
	return true ;
}


// ŵQ_̌oHT( ߂l  true:oH\z  false:oH\zs( X^[gn_ƃS[n_qoH ) )
bool SetupPathPlanning( VECTOR StartPos, VECTOR GoalPos )
{
	int i ;
	int PolyIndex ;
	PATHPLANNING_UNIT *PUnit ;
	PATHPLANNING_UNIT *PUnitSub ;
	PATHPLANNING_UNIT *PUnitSub2 ;
	bool Goal ;

	// X^[gʒuƃS[ʒuۑ
	PathPlanning.StartPosition = StartPos ;
	PathPlanning.GoalPosition = GoalPos ;

	// oHTp̃|Si[郁̈mۂ
	PathPlanning.UnitArray = ( PATHPLANNING_UNIT * )malloc( sizeof( PATHPLANNING_UNIT ) * PolyList.PolygonNum ) ;

	// oHTp̃|S
	PUnit = PathPlanning.UnitArray ;
	for( i = 0 ; i < PolyList.PolygonNum ; i ++, PUnit ++ )
	{
		PUnit->PolyIndex = i ;
		PUnit->TotalDistance = 0.0f ;
		PUnit->PrevPolyIndex = -1 ;
		PUnit->NextPolyIndex = -1 ;
		PUnit->ActiveNextUnit = NULL ;
	}

	// X^[gn_ɂ|S̔ԍ擾A|ŠoHTp̍\̂̃AhXۑ
	PolyIndex = CheckOnPolyIndex( StartPos ) ;
	if( PolyIndex == -1 )
		return false ;
	PathPlanning.StartUnit = &PathPlanning.UnitArray[ PolyIndex ] ;

	// oHTΏۂ̃|SƂăX^[gn_ɂ|So^
	PathPlanning.ActiveFirstUnit = &PathPlanning.UnitArray[ PolyIndex ] ;

	// S[n_ɂ|S̔ԍ擾A|ŠoHTp̍\̂̃AhXۑ
	PolyIndex = CheckOnPolyIndex( GoalPos ) ;
	if( PolyIndex == -1 )
		return false ;
	PathPlanning.GoalUnit = &PathPlanning.UnitArray[ PolyIndex ] ;

	// S[n_ɂ|SƃX^[gn_ɂ|S false Ԃ
	if( PathPlanning.GoalUnit == PathPlanning.StartUnit )
		return false ;

	// oHTăS[n_̃|Sɂǂ蒅܂Ń[vJԂ
	Goal = false ;
	while( Goal == false )
	{
		// oHTΏۂɂȂĂ|Sׂď
		PUnit = PathPlanning.ActiveFirstUnit ;
		PathPlanning.ActiveFirstUnit = NULL ;
		for( ; PUnit != NULL ; PUnit = PUnit->ActiveNextUnit )
		{
			// |S̕ӂ̐JԂ
			for( i = 0 ; i < 3 ; i ++ )
			{
				// ӂɗאڂ|Sꍇ͉Ȃ
				if( PolyLinkInfo[ PUnit->PolyIndex ].LinkPolyIndex[ i ] == -1 )
					continue ;

				// אڂ|SɌoHTsĂāA苗̒oHƂȂĂ邩A
				// X^[gn_̃|Sꍇ͉Ȃ
				PUnitSub = &PathPlanning.UnitArray[ PolyLinkInfo[ PUnit->PolyIndex ].LinkPolyIndex[ i ] ] ;
				if( ( PUnitSub->PrevPolyIndex != -1 && PUnitSub->TotalDistance <= PUnit->TotalDistance + PolyLinkInfo[ PUnit->PolyIndex ].LinkPolyDistance[ i ] )
					|| PUnitSub->PolyIndex == PathPlanning.StartUnit->PolyIndex )
					continue ;

				// אڂ|SS[n_ɂ|SS[ɒH蒅tO𗧂Ă
				if( PUnitSub->PolyIndex == PathPlanning.GoalUnit->PolyIndex )
				{
					Goal = true ;
				}

				// אڂ|SɌoHƂȂ鎩̃|S̔ԍ
				PUnitSub->PrevPolyIndex = PUnit->PolyIndex ;

				// אڂ|SɂɓB܂ł̋
				PUnitSub->TotalDistance = PUnit->TotalDistance + PolyLinkInfo[ PUnit->PolyIndex ].LinkPolyDistance[ i ] ;

				// ̃[vōsoHTΏۂɒǉAɒǉĂǉȂ
				for( PUnitSub2 = PathPlanning.ActiveFirstUnit ; PUnitSub2 != NULL ; PUnitSub2 = PUnitSub2->ActiveNextUnit )
				{
					if( PUnitSub2 == PUnitSub )
						break ;
				}
				if( PUnitSub2 == NULL )
				{
					PUnitSub->ActiveNextUnit = PathPlanning.ActiveFirstUnit ;
					PathPlanning.ActiveFirstUnit = PUnitSub ;
				}
			}
		}

		// ɂ PathPlanning.ActiveFirstUnit  NULL ƂƂ
		// X^[gn_ɂ|SS[n_ɂ|SɒH蒅ȂƂƂȂ̂ false Ԃ
		if( PathPlanning.ActiveFirstUnit == NULL )
		{
			return false ;
		}
	}

	// S[n_̃|SX^[gn_̃|SɒH
	// oH̃|SɎɈړׂ|S̔ԍ
	PUnit = PathPlanning.GoalUnit ;
	do
	{
		PUnitSub = PUnit ;
		PUnit = &PathPlanning.UnitArray[ PUnitSub->PrevPolyIndex ] ;

		PUnit->NextPolyIndex = PUnitSub->PolyIndex ;

	}while( PUnit != PathPlanning.StartUnit ) ;

	// ɂX^[gn_S[n_܂ł̌oHTłƂƂȂ̂ true Ԃ
	return true ;
}

// oHŤn
void TerminatePathPlanning( void )
{
	// oHTׂ̈Ɋmۂ̈
	free( PathPlanning.UnitArray ) ;
	PathPlanning.UnitArray = NULL ;
}

// ToHړ鏈̏s֐
void MoveInitialize( void )
{
	// ړJn_ŏĂ|S̓X^[gn_ɂ|S
	PathMove.NowPolyIndex = PathPlanning.StartUnit->PolyIndex ;

	// ړJn_̍W̓X^[gn_ɂ|S̒SW
	PathMove.NowPosition = PolyLinkInfo[ PathMove.NowPolyIndex ].CenterPosition ;

	// ړJn_̌oHT̓X^[gn_ɂ|S̏
	PathMove.NowPathPlanningUnit = PathPlanning.StartUnit ;

	// ړJn_̈ړԒn_̌oHTX^[gn_ɂ|S̏
	PathMove.TargetPathPlanningUnit = PathPlanning.StartUnit ;
}

// ToHړ鏈̂Pt[̏s֐
void MoveProcess( void )
{
	// ړ̍XVAS[ɒH蒅Ăړ͂ɏI
	if( RefreshMoveDirection() )
		return ;

	// ړɍWړ
	PathMove.NowPosition = VAdd( PathMove.NowPosition, VScale( PathMove.MoveDirection, MOVESPEED ) ) ;

	// ݂̍WŏĂ|S
	PathMove.NowPolyIndex = CheckOnPolyIndex( PathMove.NowPosition ) ;

	// ݂̍WŏĂ|ŠoHT̃AhX
	PathMove.NowPathPlanningUnit = &PathPlanning.UnitArray[ PathMove.NowPolyIndex ] ;
}

// ToHړ鏈ňړXV鏈s֐( ߂l  true:S[ɒH蒅Ă  false:S[ɒH蒅ĂȂ )
bool RefreshMoveDirection( void )
{
	PATHPLANNING_UNIT *TempPUnit ;

	// ݏĂ|SS[n_ɂ|S̏ꍇ͏𕪊
	if( PathMove.NowPathPlanningUnit == PathPlanning.GoalUnit )
	{
		// ͖ڕWW
		PathMove.MoveDirection = VSub( PathPlanning.GoalPosition, PathMove.NowPosition ) ;
		PathMove.MoveDirection.y = 0.0f ;

		// ڕWW܂ł̋ړxȉS[ɒHƂɂ
		if( VSize( PathMove.MoveDirection ) <= MOVESPEED )
		{
			return true ;
		}

		// ȊȌꍇ͂܂ǂ蒅ĂȂ̂ƂĈړ
		PathMove.MoveDirection = VNorm( PathMove.MoveDirection ) ;

		return false ;
	}

	// ݏĂ|SړԒn_̃|S̏ꍇ͎̒Ԓn_肷鏈s
	if( PathMove.NowPathPlanningUnit == PathMove.TargetPathPlanningUnit )
	{
		// ̒Ԓn_肷܂Ń[v
		for(;;)
		{
			TempPUnit = &PathPlanning.UnitArray[ PathMove.TargetPathPlanningUnit->NextPolyIndex ] ;

			// oH̎̃|S̒SWɒIɈړłȂꍇ̓[v甲
			if( CheckPolyMoveWidth( PathMove.NowPosition, PolyLinkInfo[ TempPUnit->PolyIndex ].CenterPosition, COLLWIDTH ) == false )
				break ;

			// `FbNΏۂoH̍XɈ̃|SɕύX
			PathMove.TargetPathPlanningUnit = TempPUnit ;

			// S[n_̃|S烋[v𔲂
			if( PathMove.TargetPathPlanningUnit == PathPlanning.GoalUnit )
				break ;
		}
	}

	// ړ肷Aړ݂͌̍W璆Ԓn_̃|S̒SWɌ
	PathMove.MoveDirection = VSub( PolyLinkInfo[ PathMove.TargetPathPlanningUnit->PolyIndex ].CenterPosition, PathMove.NowPosition ) ;
	PathMove.MoveDirection.y = 0.0f ;
	PathMove.MoveDirection = VNorm( PathMove.MoveDirection ) ;

	// ɗƂƂ̓S[ɒH蒅ĂȂ̂ false Ԃ
	return false ;
}


// WinMain ֐
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	PATHPLANNING_UNIT *PUnit ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 ) return -1 ;

	// Xe[Wf̓ǂݍ
	StageModelHandle = MV1LoadModel( "PathPlanning.mqo" ) ;

	// Xe[Wf̃|Sm̘A\z
	SetupPolyLinkInfo() ;

	// ŵQ_̌oHT
	SetupPathPlanning( VGet( -7400.0f, 0.0f, -7400.0f ), VGet( 7400.0f, 0.0f, 7400.0f ) ) ;

	// ToHړ鏀s
	MoveInitialize() ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// C[v(L[ꂽ烋[v𔲂)
	while( ProcessMessage() == 0 )
	{
		// ʂ̏
		ClearDrawScreen() ;

		// Pt[oHړ
		MoveProcess() ;

		// J̐ݒ
		SetCameraPositionAndTarget_UpVecY( VGet( -0.000f, 15692.565f, -3121.444f ), VGet( 0.000f, 0.000f, 0.000f ) ) ;
		SetCameraNearFar( 320.000f, 80000.000f ) ;

		// Xe[Wf`悷
		MV1DrawModel( StageModelHandle ) ;

		// ToH̃|S̗֊s`悷( fobO\ )
		PUnit = PathPlanning.GoalUnit ;
		for(;;)
		{
			DrawTriangle3D(
				PolyList.Vertexs[ PolyList.Polygons[ PUnit->PolyIndex ].VIndex[ 0 ] ].Position,
				PolyList.Vertexs[ PolyList.Polygons[ PUnit->PolyIndex ].VIndex[ 1 ] ].Position,
				PolyList.Vertexs[ PolyList.Polygons[ PUnit->PolyIndex ].VIndex[ 2 ] ].Position,
				GetColor( 255,0,0 ),
				FALSE
			) ;

			if( PUnit->PrevPolyIndex == -1 )
				break ;

			PUnit = &PathPlanning.UnitArray[ PUnit->PrevPolyIndex ] ;
		}

		// ړ̌ݍWɋ̂`悷
		DrawSphere3D( VAdd( PathMove.NowPosition, VGet( 0.0f, 40.0f, 0.0f ) ), SPHERESIZE, 10, GetColor( 255,0,0 ), GetColor( 0,0,0 ), TRUE ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// oȞn
	TerminatePathPlanning() ;

	// Xe[Wf̃|Sm̘Ǎn
	TerminatePolyLinkInfo() ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
